﻿' Licensed to the .NET Foundation under one or more agreements.
' The .NET Foundation licenses this file to you under the MIT license.
' See the LICENSE file in the project root for more information.

Namespace Microsoft.CodeAnalysis.Editor.UnitTests.Rename.CSharp
    <[UseExportProvider]>
    Public Class InteractiveTests
        Private ReadOnly _outputHelper As Abstractions.ITestOutputHelper

        Public Sub New(outputHelper As Abstractions.ITestOutputHelper)
            _outputHelper = outputHelper
        End Sub

        <Fact>
        <Trait(Traits.Feature, Traits.Features.Rename)>
        Public Sub RenamingTopLevelMethodsSupported()
            Using result = RenameEngineResult.Create(_outputHelper,
                <Workspace>
                    <Submission Language="C#" CommonReferences="true">
void [|$$Goo|]()
{
}
                    </Submission>
                </Workspace>, renameTo:="BarBaz")

            End Using
        End Sub
    End Class
End Namespace
