﻿// Licensed to the .NET Foundation under one or more agreements.
// The .NET Foundation licenses this file to you under the MIT license.
// See the LICENSE file in the project root for more information.

using System.Collections.Immutable;
using System.Composition;
using Microsoft.CodeAnalysis.CodeStyle;
using Microsoft.CodeAnalysis.Options;
using Microsoft.CodeAnalysis.Options.Providers;

namespace Microsoft.CodeAnalysis.CSharp.CodeStyle
{
    [ExportOptionProvider(LanguageNames.CSharp), Shared]
    internal class CSharpCodeStyleOptionsProvider : IOptionProvider
    {
        [ImportingConstructor]
        public CSharpCodeStyleOptionsProvider()
        {
        }

        public ImmutableArray<IOption> Options { get; } = CSharpCodeStyleOptions.AllOptions;
    }
}
